export function getSourceTags(source) {

  const tags = source.getTags();
  const waypointTags = {
    "waypointName": [],
    "waypointOwner": []
  };

  for (const tag in tags) {
    if (tags[tag].startsWith('{"player":{')) {

      const waypointData = JSON.parse(tags[tag]);

      waypointTags["waypointName"].push(waypointData['player']['Name']);
      waypointTags["waypointOwner"].push(waypointData['player']['Owner']);
    }
  }
  return waypointTags;
}

export function message(source, message) {
  source.playSound("random.orb");
  source.sendMessage(message);
}

export function sourceTeleport(source, entities, selection, getWaypoint) {
  for (let entity of entities) {
    if (entity.hasTag(getWaypoint['waypointName'][selection - 2])) {
      source.playSound("mob.shulker.teleport");
      source.runCommandAsync("particle chetty:waypoint_teleport_paricle ~~~");
      source.runCommandAsync(`tp "${source.nameTag}" @e[tag="${getWaypoint['waypointName'][selection - 2]}"]`);
      entity.triggerEvent("particle");
    }
  }
}

 

export function getWaypointTags(data1, data2) {
  for (const entity of data1) { //OBTENER TAGS DE LA ENTIDAD WAYPOINT
    const tags = entity.getTags();

    for (const i in tags) {
      if (tags[i].startsWith('{"waypoint":{')) {
        const waypointData = JSON.parse(tags[i]);
        data2["waypointName"].push(waypointData['waypoint']['Name']);
        data2["waypointOwner"].push(waypointData['waypoint']['Owner']);
      }
    }
  }
}