/**
 * <=<=< WAYPOINTS ADDON >=>=>
 * BY O CHETTY O
 */

import {
  world
} from "@minecraft/server";

import {
  ActionFormData
} from "@minecraft/server-ui";

import {
  WaypointAddMenu,
  waypointConfirmationMessage,
  WaypointEditMenu
} from "./forms";

import {
  getSourceTags,
  message,
  sourceTeleport,
  getWaypointTags
} from "./functions";

const text = "§6§l===========================§r";

//* ==================== Menú Principal ==================== *//
export function waypoint_main_manu(source, entities) {

  const tags = source.getTags();
  const getWaypoint = getSourceTags(source);
  const WaypointMainMenu = new ActionFormData() //FORMULARIO PRINCIPAL
    .title("§c§l« %deathScreen.quit »")
    .body("§b%hostOption.teleport:")
    .button("§0§l§k||||§r" + " §0§l%menu.options " + "§l§k||||", "textures/icon/ic_options")
    .button("§0§l§k||||§r" + " §0§l%controller.buttonTip.recipes.showAll " + "§l§k||||", "textures/icon/ic_show_all");

  for (const tag in tags) { //CICLO PARA BUSCAR TAG
    if (tags[tag].startsWith('{"player":{')) { //MOSTRAR BOTONES SI CUENTA CON TAG

      //VARIABLES
      const TagData = JSON.parse(tags[tag]);
      const waypointName = TagData['player']['Name'];

      //BOTON CON LOS WAYPOINTS
      WaypointMainMenu.button("§0§l" + waypointName, "textures/icon/ic_waypoint");
    }
  }

  WaypointMainMenu.show(source).then(({ selection }) => { // MAIN MENU
    switch (selection) {
      case 0:
        waypoints_menu_options(source, entities);
        break;
      case 1:
        waypoint_menu_show_all(source, entities);
        break;
      default:
        sourceTeleport(source, entities, selection, getWaypoint);
        break;
    }
  });
}

//* ==================== Menú De Opciones ==================== *//
function waypoints_menu_options(source, entities) {

  const getWaypoint = getSourceTags(source);
  const waypoint_menu_options = new ActionFormData()
    .title("§c§l« %menu.options »")
    .button("§0§l§k||||§r" + " §l§0%playscreen.new " + "§l§k||||", "textures/icon/ic_plus")
    .button("§0§l§k||||§r" + " §l§0%gui.delete " + "§l§k||||", "textures/icon/ic_trash")
    .button("§0§l§k||||§r" + " §l§0%gui.edit " + "§l§k||||", "textures/icon/ic_edit");

  if (source.isOp() === true) {
    waypoint_menu_options.button("§0§l§k||||§r" + " §0§l%permissions.level.operator " + "§l§k||||", "textures/icon/ic_op");
  }

  waypoint_menu_options.body(text + "\n§l%jigsaw.title.name §b§o" + source.nameTag + "\n§r§lWaypoints: §a§o" + getWaypoint['waypointName'].length + "/30§r\n" + text + "\n");
  waypoint_menu_options.show(source).then(({ selection }) => { // MAIN MENU
    switch (selection) {
      case 0: // Opcion: Agregar
        // PERMITE AGREGAR WAYPOINTS MIENTRAS QUE SEA MENOR AL LIMITE ESTABLECIDO
        if (getWaypoint['waypointName'].length < 30) {
          waypoint_menu_add_option(source, entities);
        } else if (getWaypoint['waypointName'].length >= 30) {
          message(source, "§c%chetty.ui.limit");
        }
        break;
      case 1: // Opcion: Eliminar
        waypoint_menu_remove_option(source, entities)
        break;
      case 2: // Opcion: Editar
        waypoint_menu_edit_option(source, entities);
        break;
      case 3: // Opcion: Editar
        waypoint_menu_operator_option(source, entities)
        break;
      default:
        waypoint_main_manu(source, entities);
        break
    }
  });
}

//* ==================== Menú Para Mostrar Todos Los Waypoints Globales ==================== *//
function waypoint_menu_show_all(source, entities) {

  const waypointShowAll = new ActionFormData()
    .title("§c§l« %gui.all »")
    .body("§b%hostOption.teleport:")
  const waypointTags = {
    "waypointName": [],
    "waypointOwner": []
  };

  for (const entity of entities) { //OBTENER TAGS DE LA ENTIDAD WAYPOINT Y MOSTRAR BOTONES 

    const tags = entity.getTags();

    for (const tag in tags) {
      if (tags[tag].startsWith('{"waypoint":{')) {

        const waypointData = JSON.parse(tags[tag]);
        const waypointName = waypointData['waypoint']['Name'];

        waypointTags["waypointName"].push(waypointData['waypoint']['Name']);

        waypointShowAll.button("§0§l" + waypointName, "textures/icon/ic_waypoint");
      }
    }
  }

  if (!waypointTags['waypointName'].length) { //MOSTRAR MENSAJE SI NO HAY WAYPOINTS
    message(source, "§c%chetty.ui.list.empty");
    return;
  }

  waypointShowAll.show(source).then(({ selection, canceled }) => {
    switch (canceled) {
      case false:
        getWaypointTags(entities, waypointTags); //FUNCION PARA OBTER TAGS 

        //HACER TP AL WAYPOINT SELECCIONADO
        source.runCommandAsync(`tp "${source.nameTag}" @e[tag="${waypointTags['waypointName'][selection]}"]`);
        source.runCommandAsync(`event entity @e[tag="${waypointTags['waypointName'][selection]}"] particle`);
        break;
      default:
        waypoint_main_manu(source, entities);
        break;
    }

  });
}

//* ==================== Menú Para Agregar [1] ==================== *//
function waypoint_menu_add_option(source, entities) {
  WaypointAddMenu.show(source).then(({ formValues, canceled }) => { // Nuevo Menú De Agregar
    if (canceled === false) {
      if (formValues[0].trim() !== "") {
        const entityFound = entities.find(entity => entity.hasTag(formValues[0]));
        if (entityFound) {
          message(source, "§c%chetty.ui.entity.invalid.name");
        } else {
          switch (formValues[1]) { // DROPDOWN 2 - TEXTO DE COLORES
            case 0: // Texto Negro
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§0");
              break;
            case 1: // Texto Azul Oscuro
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§1");
              break;
            case 2: // Texto Verde Oscuro
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§2");
              break;
            case 3: // Texto Aqua Oscuro
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§3");
              break;
            case 4: // Texto Rojo Oscuro
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§4");
              break;
            case 5: // Texto Púrpura Oscuro
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§5");
              break;
            case 6: // Texto Dorado
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§6");
              break;
            case 7: // Texto Gris
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§7");
              break;
            case 8: // Texto Gris Oscuro
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§8");
              break;
            case 9: // Texto Azul
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§9");
              break;
            case 10: // Texto Verde
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§a");
              break;
            case 11: // Texto Aqua
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§b");
              break;
            case 12: // Texto Rojo
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§c");
              break;
            case 13: // Texto Púrpura Claro
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§d");
              break;
            case 14: // Texto Amarillo
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§e");
              break;
            case 15: // Texto Blanco
              waypointColor(source, formValues[2], formValues[3], formValues[0], "§f");
              break;
          }
        }
      } else {
        message(source, "§c%disconnectionScreen.invalidName");
      }
    } else {
      waypoints_menu_options(source, entities);
    }
  });
}

//* ==================== Seleccion De Colores Del Waypoint [2] ==================== *//
function waypointColor(a, b, c, d, e) {
  const jsonDBP = { 'player': { 'Name': d, 'Owner': a.nameTag } }
  const jsonDBW = { 'waypoint': { 'Name': d, 'Owner': a.nameTag } }
  switch (b) { // DROPDOWN 3 - WAYPOINT DE COLORES
    case 0: // Color Negro
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_black");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_black");
          break;
        default: ""
          break;
      }
      break;
    case 1: // Color Azul
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_blue");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_blue");
          break;
      }
      break;
    case 2: // Color Marrón
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_brown");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_brown");
          break;
      }
      break;
    case 3: // Color Cian
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_cyan");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_cyan");
          break;
      }
      break;
    case 4: // Color Gris
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_gray");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_gray");
          break;
      }
      break;
    case 5: // Color Verde
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_green");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_green");
          break;
      }
      break;
    case 6: // Color Celeste
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_light_blue");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_light_blue");
          break;
      }
      break;
    case 7: // Color Verde Lima
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_lime");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_lime");
          break;
      }
      break;
    case 8: // Color Magenta
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_magenta");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_magenta");
          break;
      }
      break;
    case 9: // Color Naranja
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_orange");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_orange");
          break;
      }
      break;
    case 10: // Color Rosa
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_pink");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_pink");
          break;
      }
      break;
    case 11: // Color Morado
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_purple");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_purple");
          break;
      }
      break;
    case 12: // Color Rojo
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_red");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_red");
          break;
      }
      break;
    case 13: // Color Gris Claro
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_light_gray");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_light_gray");
          break;
      }
      break;
    case 14: // Color Blanco
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_white");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_white");
          break;
      }
      break;
    case 15: // Color Amarillo
      switch (c) { // DROPDOWN 4 - Mostrar El Waypoint En Otros Mapas
        case 0: // Mostrar
          createWaypoint(a, d, jsonDBP, jsonDBW, e, "add_yellow");
          break;
        case 1: // Ocultar
          createWaypoint(a, d, jsonDBP, "", e, "add_yellow");
          break;
      }
      break;
  }
}

function createWaypoint(a, b, c, d, e, f) {
  const position = a.location;
  const { x, y, z } = position;
  const waypoint = a.dimension.spawnEntity("chetty:waypoint_beam", { x, y, z });
  waypoint.runCommandAsync(`tp @s ${Math.round(x)} ${Math.round(y)} ${Math.round(z)}`);
  waypoint.nameTag = "§l" + e + "« " + b + " »";
  waypoint.addTag(JSON.stringify(d));
  waypoint.addTag(b);
  a.addTag(JSON.stringify(c))
  waypoint.triggerEvent(f);
  message(a, "§a%chetty.ui.added [ " + b + " ] %chetty.ui.list1");
}

//* ==================== Menu Para Eliminar ==================== *//
function waypoint_menu_remove_option(source, entities) {
  const WaypointRemoveMenu = new ActionFormData().title("§c§l« %gui.delete »").body("§b%emote_wheel.gamepad_helper.select:");
  const getWaypoint = getSourceTags(source);
  const tags = source.getTags();
  if (!getWaypoint['waypointName'].length) { //MOSTRAR MENSAJE SI NO HAY WAYPOINTS
    message(source, "§c%chetty.ui.list.empty"); return;
  }
  for (const tag in tags) { //CICLO PARA BUSCAR TAG
    if (tags[tag].startsWith('{"player":{')) { //MOSTRAR BOTONES SI CUENTA CON TAG
      const TagData = JSON.parse(tags[tag]);
      const waypointName = TagData['player']['Name'];
      WaypointRemoveMenu.button("§0§l" + waypointName, "textures/icon/ic_trash");
    }
  }
  WaypointRemoveMenu.show(source).then(({ selection, canceled }) => {
    waypointConfirmationMessage.body("%xbl.signOut.message2\n\n%gui.delete: §a" + getWaypoint['waypointName'][selection]);
    const findJsonDB = { 'player': { 'Name': getWaypoint['waypointName'][selection], 'Owner': source.nameTag } };
    if (canceled === false) {
      for (const entity of entities) {
        if (entity.hasTag(`${getWaypoint['waypointName'][selection]}`)) {
          waypointConfirmationMessage.show(source).then(({ selection }) => {
            if (selection === 0) {
              message(source, "§c%chetty.ui.removed [ " + getWaypoint['waypointName'][selection] + " ] %chetty.ui.list2");
              entity.triggerEvent("waypoint_remove");
              source.removeTag(JSON.stringify(findJsonDB));
              const dimension = world.getDimension('overworld') || world.getDimension('nether') || world.getDimension('theEnd');
              const entities = Array.from(dimension.getEntities({ type: "chetty:waypoint_beam" }));
              waypoint_menu_remove_option(source, entities);
            } else if (selection === 1) {
              waypoint_menu_remove_option(source, entities);
            }
          });
        }
      }
    } else {
      waypoints_menu_options(source, entities);
    }
  });
}

//* ==================== Menu Para Editar ==================== *//
function waypoint_menu_edit_option(source, entities) {
  const WaypointSelectToEditMenu = new ActionFormData().title("§c§l« %gui.edit »").body("§b%emote_wheel.gamepad_helper.select:");
  const getWaypoint = getSourceTags(source);
  const tags = source.getTags();
  if (!getWaypoint['waypointName'].length) { //MOSTRAR MENSAJE SI NO HAY WAYPOINTS
    message(source, "§c%chetty.ui.list.empty"); return;
  }
  for (const tag in tags) { //CICLO PARA BUSCAR TAG
    if (tags[tag].startsWith('{"player":{')) { //MOSTRAR BOTONES SI CUENTA CON TAG
      const TagData = JSON.parse(tags[tag]);
      const waypointName = TagData['player']['Name'];
      WaypointSelectToEditMenu.button("§l§0" + waypointName, "textures/icon/ic_edit");
    }
  }
  WaypointSelectToEditMenu.show(source).then(({ selection, canceled }) => {
    if (canceled === false) {
      for (const entity of entities) {
        if (entity.hasTag(`${getWaypoint['waypointName'][selection]}`)) {
          menu_edit_waypoint_0(source, entity, entities);
        }
      }
    } else {
      waypoints_menu_options(source, entities);
    }
  });
}

function menu_edit_waypoint_0(source, entity, entities) {
  WaypointEditMenu.show(source).then(({ formValues, canceled }) => {
    if (canceled === false) {
      switch (formValues[0]) {
        case 0:
          menu_edit_waypoint_1(source, entities, entity, formValues);
          break;
        case 1:
          menu_edit_waypoint_2(source, entities, entity, formValues);
          break;
        case 2:
          menu_edit_waypoint_3(source, entities, entity, formValues);
          break;
      }
    } else {
      waypoint_menu_edit_option(source, entities);
    }
  });
}

function menu_edit_waypoint_1(source, entities, entity, formValues) {
  switch (formValues[1]) { // DROPDOWN 2 - Colores Del Waypoint
    case 0: // Por Defecto
      menu_edit_waypoint_4(source, entities, entity, formValues, "", "set_show_name", "set_hide_name", "");
      break;
    case 1: // Haz Negro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_black", "set_show_name", "set_hide_name", "");
      break;
    case 2: // Texto Azul Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_blue", "set_show_name", "set_hide_name", "");
      break;
    case 3: // Texto Verde Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_brown", "set_show_name", "set_hide_name", "");
      break;
    case 4: // Texto Aqua Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_cyan", "set_show_name", "set_hide_name", "");
      break;
    case 5: // Texto Rojo Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_gray", "set_show_name", "set_hide_name", "");
      break;
    case 6: // Texto Púrpura Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_green", "set_show_name", "set_hide_name", "");
      break;
    case 7: // Texto Dorado
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_light_blue", "set_show_name", "set_hide_name", "");
      break;
    case 8: // Texto Gris
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_lime", "set_show_name", "set_hide_name", "");
      break;
    case 9: // Texto Gris Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_magenta", "set_show_name", "set_hide_name", "");
      break;
    case 10: // Texto Azul
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_orange", "set_show_name", "set_hide_name", "");
      break;
    case 11: // Texto Verde
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_pink", "set_show_name", "set_hide_name", "");
      break;
    case 12: // Texto Aqua
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_purple", "set_show_name", "set_hide_name", "");
      break;
    case 13: // Texto Rojo
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_red", "set_show_name", "set_hide_name", "");
      break;
    case 14: // Texto Púrpura Claro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_light_gray", "set_show_name", "set_hide_name", "");
      break;
    case 15: // Texto Amarillo
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_white", "set_show_name", "set_hide_name", "");
      break;
    case 16: // Texto Blanco
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_yellow", "set_show_name", "set_hide_name", "");
      break;
  }
}

function menu_edit_waypoint_2(source, entities, entity, formValues) {
  switch (formValues[1]) { // DROPDOWN 2 - Colores Del Waypoint
    case 0: // Por Defecto
      menu_edit_waypoint_4(source, entities, entity, formValues, "", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 1: // Haz Negro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_black", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 2: // Texto Azul Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_blue", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 3: // Texto Verde Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_brown", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 4: // Texto Aqua Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_cyan", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 5: // Texto Rojo Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_gray", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 6: // Texto Púrpura Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_green", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 7: // Texto Dorado
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_light_blue", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 8: // Texto Gris
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_lime", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 9: // Texto Gris Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_magenta", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 10: // Texto Azul
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_orange", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 11: // Texto Verde
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_pink", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 12: // Texto Aqua
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_purple", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 13: // Texto Rojo
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_red", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 14: // Texto Púrpura Claro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_light_gray", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 15: // Texto Amarillo
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_white", "set_show_name", "set_hide_name", "set_show_beam");
      break;
    case 16: // Texto Blanco
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_yellow", "set_show_name", "set_hide_name", "set_show_beam");
      break;
  }
}

function menu_edit_waypoint_3(source, entities, entity, formValues) {
  switch (formValues[1]) { // DROPDOWN 2 - Colores Del Waypoint
    case 0: // Por Defecto
      menu_edit_waypoint_4(source, entities, entity, formValues, "", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 1: // Haz Negro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_black", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 2: // Texto Azul Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_blue", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 3: // Texto Verde Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_brown", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 4: // Texto Aqua Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_cyan", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 5: // Texto Rojo Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_gray", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 6: // Texto Púrpura Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_green", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 7: // Texto Dorado
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_light_blue", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 8: // Texto Gris
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_lime", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 9: // Texto Gris Oscuro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_magenta", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 10: // Texto Azul
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_orange", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 11: // Texto Verde
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_pink", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 12: // Texto Aqua
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_purple", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 13: // Texto Rojo
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_red", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 14: // Texto Púrpura Claro
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_light_gray", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 15: // Texto Amarillo
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_white", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
    case 16: // Texto Blanco
      menu_edit_waypoint_4(source, entities, entity, formValues, "add_yellow", "set_show_name", "set_hide_name", "set_hide_beam");
      break;
  }
}

function menu_edit_waypoint_4(source, entities, entity, formValues, event1, event2, event3, event4) {
  switch (formValues[2]) {
    case 0:
      entity.triggerEvent(event1);
      entity.triggerEvent(event4);
      waypoint_menu_edit_option(source, entities);
      message(source, "§a%chetty.ui.changes");
      break;
    case 1:
      entity.triggerEvent(event1);
      entity.triggerEvent(event2);
      entity.triggerEvent(event4);
      waypoint_menu_edit_option(source, entities);
      message(source, "§a%chetty.ui.changes");
      break;
    case 2:
      entity.triggerEvent(event1);
      entity.triggerEvent(event3);
      entity.triggerEvent(event4);
      waypoint_menu_edit_option(source, entities);
      message(source, "§a%chetty.ui.changes");
      break;
  }
}

function waypoint_menu_operator_option(source, entities) {
  const waypointNames = [];
  const operatorMenu = new ActionFormData().title("§c§l« %permissions.level.operator »").body("§b%emote_wheel.gamepad_helper.select:");
  for (const entity of entities) { //OBTENER TAGS DE LA ENTIDAD WAYPOINT Y MOSTRAR BOTONES 
    if (entity.nameTag.startsWith('§')) {
      waypointNames.push(entity.nameTag);
      operatorMenu.button(entity.nameTag, 'textures/icon/ic_trash');
    }
  }
  if (!waypointNames.length) { //MOSTRAR MENSAJE SI NO HAY WAYPOINTS
    message(source, "§c%chetty.ui.list.empty"); return;
  }
  operatorMenu.show(source).then(({ selection, canceled }) => {
    waypointConfirmationMessage.body("%xbl.signOut.message2\n\n§c%gui.delete: §a" + waypointNames[selection]);
    if (canceled === false) {
      for (const entity of entities) {
        if (entity.nameTag.includes(`${waypointNames[selection]}`)) {
          waypointConfirmationMessage.show(source).then(({ selection }) => {
            if (selection === 0) {
              const dimension = world.getDimension('overworld') || world.getDimension('nether') || world.getDimension('theEnd');
              const entities = Array.from(dimension.getEntities({ type: "chetty:waypoint_beam" }));
              entity.triggerEvent("waypoint_remove");
              message(source, "§c%feed.deleted");
              waypoint_menu_operator_option(source, entities);
            } else if (selection === 1) {
              waypoint_menu_operator_option(source, entities);
            }
          });
        } return;
      }
    } else {
      waypoints_menu_options(source, entities);
    }
  });
}